# glance.image_cache.drivers.xattr module

Cache driver that uses xattr file tags and requires a filesystem that has atimes set.

## Assumptions

1. Cache data directory exists on a filesystem that updates atime on reads (‘noatime’ should NOT be set)

2. Cache data directory exists on a filesystem that supports xattrs. This is optional, but highly recommended since it allows us to present ops with useful information pertaining to the cache, like human readable filenames and statistics.

3. glance-prune is scheduled to run as a periodic job via cron. This

     is needed to run the LRU prune strategy to keep the cache size within the limits set by the config file.

## Cache Directory Notes

The image cache data directory contains the main cache path, where the active cache entries and subdirectories for handling partial downloads and errored-out cache images.

The layout looks like:

$image_cache_dir/

  entry1 entry2 … incomplete/ invalid/ queue/

class glance.image_cache.drivers.xattr.Driver

  Bases: `Driver`

  Cache driver that uses xattr file tags and requires a filesystem that has atimes set.

  clean(stall_time=None)

    Delete any image files in the invalid directory and any files in the incomplete directory that are older than a configurable amount of time.

  configure()

    Configure the driver to use the stored configuration options Any store that needs special configuration should implement this method. If the store was not able to successfully configure itself, it should raise exception.BadDriverConfiguration

  delete_all_cached_images()

    Removes all cached image files and any attributes about the images

  delete_all_queued_images()

    Removes all queued image files and any attributes about the images

  delete_cached_image(image_id)

    Removes a specific cached image file and any attributes about the image

    Parameters:

      image_id – Image ID

  delete_queued_image(image_id)

    Removes a specific queued image file and any attributes about the image

    Parameters:

      image_id – Image ID

  get_cache_size()

    Returns the total size in bytes of the image cache.

  get_cached_images()

    Returns a list of records about cached images.

  get_hit_count(image_id)

    Return the number of hits that an image has.

    Parameters:

      image_id – Opaque image identifier

  get_least_recently_accessed()

    Return a tuple containing the image_id and size of the least recently accessed cached file, or None if no cached files.

  get_queued_images()

    Returns a list of image IDs that are in the queue. The list should be sorted by the time the image ID was inserted into the queue.

  is_being_cached(image_id)

    Returns True if the image with supplied id is currently in the process of having its image file cached.

    Parameters:

      image_id – Image ID

  is_cacheable(image_id)

    Returns True if the image with the supplied ID can have its image file cached, False otherwise.

    Parameters:

      image_id – Image ID

  is_cached(image_id)

    Returns True if the image with the supplied ID has its image file cached.

    Parameters:

      image_id – Image ID

  is_queued(image_id)

    Returns True if the image identifier is in our cache queue.

  open_for_read(image_id)

    Open and yield file for reading the image file for an image with supplied identifier.

    Parameters:

      image_id – Image ID

  open_for_write(image_id)

    Open a file for writing the image file for an image with supplied identifier.

    Parameters:

      image_id – Image ID

  queue_image(image_id)

    This adds a image to be cache to the queue.

    If the image already exists in the queue or has already been cached, we return False, True otherwise

    Parameters:

      image_id – Image ID

  reap_invalid(grace=None)

    Remove any invalid cache entries

    Parameters:

      grace – Number of seconds to keep an invalid entry around for debugging purposes. If None, then delete immediately.

  reap_stalled(grace=None)

    Remove any stalled cache entries

    Parameters:

      grace – Number of seconds to keep an invalid entry around for debugging purposes. If None, then delete immediately.

glance.image_cache.drivers.xattr.delete_cached_file(path)

glance.image_cache.drivers.xattr.get_all_regular_files(basepath)

glance.image_cache.drivers.xattr.get_xattr(path, key, **kwargs)

  Return the value for a particular xattr

  If the key doesn’t not exist, or xattrs aren’t supported by the file system then a KeyError will be raised, that is, unless you specify a default using kwargs.

glance.image_cache.drivers.xattr.inc_xattr(path, key, n=1)

  Increment the value of an xattr (assuming it is an integer).

  BEWARE, this code does have a RACE CONDITION, since the read/update/write sequence is not atomic.

  Since the use-case for this function is collecting stats–not critical– the benefits of simple, lock-free code out-weighs the possibility of an occasional hit not being counted.

glance.image_cache.drivers.xattr.set_xattr(path, key, value)

  Set the value of a specified xattr.

  If xattrs aren’t supported by the file-system, we skip setting the value.

this page last updated: 2026-04-16 16:57:26

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug